Index: trunk/src/TAGS
===================================================================
--- trunk/src/TAGS	(revision 42)
+++ trunk/src/TAGS	(revision 43)
@@ -3,8 +3,14 @@
 cgb-lisp.lisp,140
 (defpackage "CGB-LISP"22,1268
-(defvar *examples*30,1582
-(defun example 91,3934
-(defun run-example 97,4159
-(defun all-examples 109,4670
+(defvar *examples*30,1598
+(defun example 91,3950
+(defun run-example 97,4175
+(defun all-examples 109,4686
+
+
+cgb-manuals.lisp,98
+(defpackage "CGB-MANUALS"13,659
+(defvar *cgb-packages*18,751
+(defun create-cgb-manuals 28,1204
 
 
@@ -43,32 +49,32 @@
 (defun colored-Criterion-2 522,21164
 (defun cond-normal-form 541,21753
-(defun cond-spoly 601,23978
-(defun cond-lm 630,25095
-(defun cond-lc 636,25294
-(defun colored-term-times-poly 642,25446
-(defun colored-scalar-times-poly 647,25637
-(defun colored-term* 655,25887
-(defun color* 662,26135
-(defun color+ 672,26403
-(defun color- 683,26712
-(defun colored-poly+ 687,26778
-(defun colored-poly- 710,27588
-(defun colored-term-uminus 733,28366
-(defun colored-minus-poly 737,28525
-(defun string-grobner-system 741,28671
-(defun string-cond 767,29664
-(defun string-cover 778,30219
-(defun saturate-cover 786,30553
-(defun saturate-cond 793,30913
-(defun string-determine 800,31214
-(defun tidy-grobner-system 818,31911
-(defun tidy-pair 826,32168
-(defun tidy-cond 847,32891
-(defun colored-reduction 853,33146
-(defun green-reduce-colored-poly 900,34825
-(defun green-reduce-colored-list 913,35347
-(defun cond-system-green-reduce 924,35699
-(defun parse-to-colored-poly-list 935,36032
-(defun red-reduction 948,36766
+(defun cond-spoly 601,23979
+(defun cond-lm 630,25096
+(defun cond-lc 636,25295
+(defun colored-term-times-poly 642,25447
+(defun colored-scalar-times-poly 647,25638
+(defun colored-term* 655,25888
+(defun color* 662,26136
+(defun color+ 672,26404
+(defun color- 683,26713
+(defun colored-poly+ 687,26779
+(defun colored-poly- 710,27589
+(defun colored-term-uminus 733,28367
+(defun colored-minus-poly 737,28526
+(defun string-grobner-system 741,28672
+(defun string-cond 767,29665
+(defun string-cover 778,30220
+(defun saturate-cover 786,30554
+(defun saturate-cond 793,30914
+(defun string-determine 800,31215
+(defun tidy-grobner-system 818,31912
+(defun tidy-pair 826,32169
+(defun tidy-cond 847,32892
+(defun colored-reduction 853,33147
+(defun green-reduce-colored-poly 900,34826
+(defun green-reduce-colored-list 913,35348
+(defun cond-system-green-reduce 924,35700
+(defun parse-to-colored-poly-list 935,36033
+(defun red-reduction 948,36767
 
 
@@ -216,96 +222,102 @@
 infix.lisp,3615
 (defpackage "INFIX"265,12470
-(defparameter *infix-readtable* 307,14148
-(defparameter *normal-readtable* 308,14202
-(defmacro infix-error 310,14258
-(defun infix-reader 314,14389
-(defun string->prefix 334,15148
-(defun read-infix 343,15440
-(defun read-regular 350,15712
-(defun same-operator-p 359,15926
-(defun same-token-p 362,15978
-(defvar *peeked-token* 369,16126
-(defun read-token 370,16154
-(defun peek-token 374,16259
-(defun fancy-number-format-p 382,16499
-(defun valid-numberp 406,17321
-(defun gather-superiors 420,17702
-(defun get-first-token 441,18625
-(defun apply-token-prefix-operator 449,18849
-(defun get-next-token 455,19052
-(defun apply-token-infix-operator 459,19179
-(defun infix-read-delimited-list 468,19472
-(defparameter *operator-ordering* 488,20222
-(defun operator-lessp 511,20854
-(defparameter *right-associative-operators* 518,21051
-(defun operator-right-associative-p 519,21103
-(defvar *token-operators* 527,21314
-(defvar *token-prefix-operator-table* 528,21345
-(defvar *token-infix-operator-table* 529,21402
-(defun token-operator-p 530,21458
-(defun get-token-prefix-operator 532,21524
-(defun get-token-infix-operator 534,21614
-(define-token-operator and574,22956
-(define-token-operator or576,23041
-(define-token-operator not578,23123
-(define-token-operator if581,23203
-(define-token-operator then603,23883
-(define-token-operator else605,23967
-(define-character-tokenization #\+608,24052
-(define-token-operator +616,24264
-(define-token-operator +=619,24383
-(define-character-tokenization #\-622,24467
-(define-token-operator -630,24679
-(define-token-operator -=633,24804
-(define-character-tokenization #\*636,24888
-(define-token-operator *644,25100
-(define-token-operator *=646,25178
-(define-character-tokenization #\/653,25324
-(define-token-operator /661,25536
-(define-token-operator /=664,25661
-(define-character-tokenization #\^671,25807
-(define-token-operator ^679,26019
-(define-token-operator ^^681,26100
-(define-character-tokenization #\|684,26186
-(define-token-operator \|692,26399
-(define-character-tokenization #\&695,26485
-(define-token-operator \&703,26699
-(define-character-tokenization #\%706,26785
-(define-token-operator \%710,26887
-(define-character-tokenization #\~713,26970
-(define-token-operator \~717,27072
-(define-character-tokenization #\,720,27153
-(define-token-operator \,724,27255
-(define-character-tokenization #\=727,27340
-(define-token-operator ===735,27552
-(define-token-operator ==737,27632
-(define-character-tokenization #\:	744,27765
-(define-token-operator |:=752,28024
-(define-character-tokenization #\<759,28206
-(define-token-operator <770,28517
-(define-token-operator <=772,28595
-(define-token-operator <<774,28676
-(define-character-tokenization #\>777,28759
-(define-token-operator >788,29070
-(define-token-operator >=790,29148
-(define-token-operator >>792,29229
-(define-character-tokenization #\!795,29316
-(define-token-operator !=803,29528
-(define-token-operator !805,29614
-(define-character-tokenization #\[808,29675
-(define-token-operator \[812,29777
-(define-character-tokenization #\(820,30092
-(define-token-operator \(824,30194
-(define-character-tokenization #\]833,30521
-(define-token-operator \]837,30623
-(define-character-tokenization #\)840,30722
-(define-token-operator \)844,30824
-(define-character-tokenization #\$849,30994
-(define-token-operator %infix-end-token%853,31111
-(define-character-tokenization #\;858,31292
-(defun post-process-expression 886,32163
-(defparameter *test-cases*930,33528
-(defun test-infix 1086,40219
-(defun test-infix-case 1095,40491
+(defparameter *infix-readtable* 307,14163
+(defparameter *normal-readtable* 308,14217
+(defmacro infix-error 310,14273
+(defun infix-reader 314,14404
+(defun string->prefix 334,15163
+(defun read-infix 343,15455
+(defun read-regular 350,15727
+(defun same-operator-p 359,15941
+(defun same-token-p 362,15993
+(defvar *peeked-token* 369,16141
+(defun read-token 370,16169
+(defun peek-token 374,16274
+(defun fancy-number-format-p 382,16514
+(defun valid-numberp 406,17336
+(defun gather-superiors 420,17717
+(defun get-first-token 441,18640
+(defun apply-token-prefix-operator 449,18864
+(defun get-next-token 455,19067
+(defun apply-token-infix-operator 459,19194
+(defun infix-read-delimited-list 468,19487
+(defparameter *operator-ordering* 488,20237
+(defun operator-lessp 511,20869
+(defparameter *right-associative-operators* 518,21066
+(defun operator-right-associative-p 519,21118
+(defvar *token-operators* 527,21329
+(defvar *token-prefix-operator-table* 528,21360
+(defvar *token-infix-operator-table* 529,21417
+(defun token-operator-p 530,21473
+(defun get-token-prefix-operator 532,21539
+(defun get-token-infix-operator 534,21629
+(define-token-operator and574,22971
+(define-token-operator or576,23056
+(define-token-operator not578,23138
+(define-token-operator if581,23218
+(define-token-operator then603,23898
+(define-token-operator else605,23982
+(define-character-tokenization #\+608,24067
+(define-token-operator +616,24279
+(define-token-operator +=619,24398
+(define-character-tokenization #\-622,24482
+(define-token-operator -630,24694
+(define-token-operator -=633,24819
+(define-character-tokenization #\*636,24903
+(define-token-operator *644,25115
+(define-token-operator *=646,25193
+(define-character-tokenization #\/653,25339
+(define-token-operator /661,25551
+(define-token-operator /=664,25676
+(define-character-tokenization #\^671,25822
+(define-token-operator ^679,26034
+(define-token-operator ^^681,26115
+(define-character-tokenization #\|684,26201
+(define-token-operator \|692,26414
+(define-character-tokenization #\&695,26500
+(define-token-operator \&703,26714
+(define-character-tokenization #\%706,26800
+(define-token-operator \%710,26902
+(define-character-tokenization #\~713,26985
+(define-token-operator \~717,27087
+(define-character-tokenization #\,720,27168
+(define-token-operator \,724,27270
+(define-character-tokenization #\=727,27355
+(define-token-operator ===735,27567
+(define-token-operator ==737,27647
+(define-character-tokenization #\:	744,27780
+(define-token-operator |:=752,28039
+(define-character-tokenization #\<759,28221
+(define-token-operator <770,28532
+(define-token-operator <=772,28610
+(define-token-operator <<774,28691
+(define-character-tokenization #\>777,28774
+(define-token-operator >788,29085
+(define-token-operator >=790,29163
+(define-token-operator >>792,29244
+(define-character-tokenization #\!795,29331
+(define-token-operator !=803,29543
+(define-token-operator !805,29629
+(define-character-tokenization #\[808,29690
+(define-token-operator \[812,29792
+(define-character-tokenization #\(820,30107
+(define-token-operator \(824,30209
+(define-character-tokenization #\]833,30536
+(define-token-operator \]837,30638
+(define-character-tokenization #\)840,30737
+(define-token-operator \)844,30839
+(define-character-tokenization #\$849,31009
+(define-token-operator %infix-end-token%853,31126
+(define-character-tokenization #\;858,31307
+(defun post-process-expression 886,32178
+(defparameter *test-cases*930,33543
+(defun test-infix 1086,40234
+(defun test-infix-case 1095,40506
+
+
+infix-printer.lisp,105
+(defpackage "INFIX-PRINTER"12,624
+(defun infix-print-separated-list 22,809
+(defun infix-print 54,1620
 
 
@@ -316,32 +328,32 @@
 (defvar *lisp-suffix* 24,972
 (defvar *cgb-packages*25,1045
-(defun package-file 92,3174
-(defun cgb-compile 95,3244
-(defun cgb-load 102,3435
-(defun cgb-load-lisp 112,3730
-(defun cgb-compile-and-load 120,3978
-(defun cgb-go 124,4040
-(defun start-cgb-lisp 128,4094
-(defun cgb-lisp-top-level-read-eval-print-loop 136,4261
-(defun cgb-lisp-banner 141,4410
-(defun cgb-save 148,4563
-(defun cgb-save 161,4916
+(defun package-file 92,3190
+(defun cgb-compile 95,3260
+(defun cgb-load 102,3451
+(defun cgb-load-lisp 112,3746
+(defun cgb-compile-and-load 120,3994
+(defun cgb-go 124,4056
+(defun start-cgb-lisp 128,4110
+(defun cgb-lisp-top-level-read-eval-print-loop 136,4277
+(defun cgb-lisp-banner 141,4426
+(defun cgb-save 148,4579
+(defun cgb-save 161,4932
 
 
 makelist.lisp,398
-(defpackage "MAKELIST"12,619
-(defmacro makelist-1 57,2296
-(defmacro makelist 64,2514
-(defmacro sum 73,2815
-(defmacro summation 76,2878
-(defmacro difference 79,2941
-(defmacro list-of 83,3060
-(defmacro list-of-1 91,3282
-(defmacro union-of 98,3485
-(defmacro union-of-1 106,3725
-(defmacro set-of 114,3944
-(defmacro set-of-1 122,4178
-(defun select 129,4392
-(defun standard-vector 134,4507
+(defpackage "MAKELIST"11,560
+(defmacro makelist-1 56,2237
+(defmacro makelist 63,2455
+(defmacro sum 72,2756
+(defmacro summation 75,2819
+(defmacro difference 78,2882
+(defmacro list-of 82,3001
+(defmacro list-of-1 90,3223
+(defmacro union-of 97,3426
+(defmacro union-of-1 105,3666
+(defmacro set-of 113,3885
+(defmacro set-of-1 121,4119
+(defun select 128,4333
+(defun standard-vector 133,4448
 
 
@@ -407,6 +419,6 @@
 (defun sort-poly 219,8789
 (defun poly-eval-1 232,9332
-(defun poly-eval 256,10353
-(defun monom-basis 273,11252
+(defun poly-eval 280,10865
+(defun monom-basis 297,11764
 
 
Index: trunk/src/cgb-manuals.lisp
===================================================================
--- trunk/src/cgb-manuals.lisp	(revision 42)
+++ trunk/src/cgb-manuals.lisp	(revision 43)
@@ -23,7 +23,4 @@
     "INFIX" "CGB-LISP"))
 
-(eval-when (:load-toplevel :compile-toplevel :execute)
-  (asdf::operate 'asdf::load-op 'cgb))
-
 ;;----------------------------------------------------------------
 ;; Generate documentation
@@ -36,4 +33,5 @@
 
 (eval-when (:load-toplevel :compile-toplevel :execute)
+  (asdf::operate 'asdf::load-op 'cgb)
   (create-cgb-manuals '../doc/ 'text)
   (create-cgb-manuals '../latex-doc/ 'latex)))