Index: /trunk/src/cgb-lisp.lisp
===================================================================
--- /trunk/src/cgb-lisp.lisp	(revision 97)
+++ /trunk/src/cgb-lisp.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: cgb-lisp.lisp,v 1.1 2009/01/19 07:44:57 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
Index: /trunk/src/coefficient-ring.lisp
===================================================================
--- /trunk/src/coefficient-ring.lisp	(revision 97)
+++ /trunk/src/coefficient-ring.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: coefficient-ring.lisp,v 1.4 2009/01/22 03:59:21 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -35,5 +34,5 @@
 (in-package "COEFFICIENT-RING")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defstruct ring
Index: /trunk/src/colored-poly.lisp
===================================================================
--- /trunk/src/colored-poly.lisp	(revision 97)
+++ /trunk/src/colored-poly.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: colored-poly.lisp,v 1.12 2009/01/24 11:07:32 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -24,5 +24,5 @@
 (in-package "COLORED-POLY")
 	     
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 #+debug(defvar *colored-poly-debug* nil "If true debugging output is on.")
Index: /trunk/src/division.lisp
===================================================================
--- /trunk/src/division.lisp	(revision 97)
+++ /trunk/src/division.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: division.lisp,v 1.4 2009/01/22 04:00:56 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -15,5 +15,5 @@
 (in-package  "DIVISION")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun divide (f fl &optional
Index: /trunk/src/dynamics.lisp
===================================================================
--- /trunk/src/dynamics.lisp	(revision 97)
+++ /trunk/src/dynamics.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: dynamics.lisp,v 1.7 2009/01/23 10:49:32 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -28,5 +27,5 @@
 (in-package "DYNAMICS")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun poly-scalar-composition (f G &optional (order #'lex>))
Index: /trunk/src/example.lisp
===================================================================
--- /trunk/src/example.lisp	(revision 97)
+++ /trunk/src/example.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: example.lisp,v 1.2 2009/01/22 04:01:51 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -17,5 +17,5 @@
     "INFIX" "COMMON-LISP"))
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun example (symbol &optional (stream t))
Index: /trunk/src/grobner.lisp
===================================================================
--- /trunk/src/grobner.lisp	(revision 97)
+++ /trunk/src/grobner.lisp	(revision 98)
@@ -1,5 +1,5 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: grobner.lisp,v 1.8 2009/01/23 10:40:26 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -55,5 +55,5 @@
 (in-package "GROBNER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 #+debug
@@ -119,5 +119,5 @@
 coefficients in a ring whose operations are the slots
 of the RING structure."
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   (let* ((lcm (monom-lcm (lm f) (lm g)))
 	 (m1 (monom/ lcm (lm f)))
@@ -172,5 +172,5 @@
 on the coefficients are performed using the RING structure from the
 COEFFICIENT-RING package."
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   ;; Loop invariant: c*f=sum ai*fi+r+p
   (do (r (c (ring-unit ring))
@@ -908,5 +908,5 @@
   C*F= sum A[i]*FL[i] + R
 "
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   (do (r
        (c (ring-unit ring))
@@ -1162,5 +1162,5 @@
 the partial remainder exceeds SUGAR-LIMIT then the calculation is stopped and the partial
 remainder is returned, although it is not fully reduced with respect to FL."
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   ;; Loop invariant: c*f=sum ai*fi+r+p
   (do ((r (cons nil 0))
@@ -1460,5 +1460,5 @@
 of pairs (MONOMIAL . PRODUCT-POLY) where PRODUCT-POLY is (POLY* MONOMIAL G)."
 
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   ;; Loop invariant: c*f=sum ai*fi+r+p
   (do (r (c (ring-unit ring))
@@ -1551,5 +1551,5 @@
 (defun cached-spoly (f g pred ring cache-f cache-g)
   "Uses CACHE to fetch products of monomials and polynomials."
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   (let* ((lcm (monom-lcm (lm f) (lm g)))
 	 (m1 (monom/ lcm (lm f)))
@@ -1585,5 +1585,5 @@
 the partial remainder exceeds SUGAR-LIMIT then the calculation is stopped and the partial
 remainder is returned, although it is not fully reduced with respect to FL."
-  (declare (optimize (speed 3) (safety 0)))
+  (declare (optimize (speed 0) (safety 3)))
   ;; Loop invariant: c*f=sum ai*fi+r+p
   (do ((r (cons nil 0))
Index: /trunk/src/infix-printer.lisp
===================================================================
--- /trunk/src/infix-printer.lisp	(revision 97)
+++ /trunk/src/infix-printer.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: infix-printer.lisp,v 1.18 2002/03/29 14:00:18 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -18,5 +18,5 @@
 (in-package "INFIX-PRINTER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun infix-print-separated-list (lst sep stream op print-level
Index: /trunk/src/infix.lisp
===================================================================
--- /trunk/src/infix.lisp	(revision 97)
+++ /trunk/src/infix.lisp	(revision 98)
@@ -1,4 +1,3 @@
-;;; -*- Mode: Lisp -*-
-;;; $Id: infix.lisp,v 1.4 2009/01/22 04:02:59 marek Exp $	
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 ;;; ****************************************************************
 ;;; CHANGE LOG:
@@ -277,5 +276,5 @@
 (pushnew :infix *features*)
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (eval-when (:compile-toplevel :load-toplevel :execute)
Index: /trunk/src/make-cgb.lisp
===================================================================
--- /trunk/src/make-cgb.lisp	(revision 97)
+++ /trunk/src/make-cgb.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-  $Id: make-cgb.lisp,v 1.3 2009/01/19 07:05:15 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
Index: /trunk/src/makelist.lisp
===================================================================
--- /trunk/src/makelist.lisp	(revision 97)
+++ /trunk/src/makelist.lisp	(revision 98)
@@ -1,2 +1,3 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
   *--------------------------------------------------------------------------*
@@ -15,5 +16,5 @@
 (in-package "MAKELIST")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 
Index: /trunk/src/modular-poly.lisp
===================================================================
--- /trunk/src/modular-poly.lisp	(revision 97)
+++ /trunk/src/modular-poly.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: modular-poly.lisp,v 1.2 2009/01/22 04:04:10 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -17,5 +16,5 @@
 (in-package "MODULAR-POLY")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun modular-trace (plist modulus)
Index: /trunk/src/modular.lisp
===================================================================
--- /trunk/src/modular.lisp	(revision 97)
+++ /trunk/src/modular.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: modular.lisp,v 1.4 2009/01/22 04:03:50 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -17,5 +16,5 @@
 (in-package "MODULAR")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun modular-inverse (x p)
Index: /trunk/src/monom.lisp
===================================================================
--- /trunk/src/monom.lisp	(revision 97)
+++ /trunk/src/monom.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: monom.lisp,v 1.3 2009/01/22 04:04:31 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -17,5 +17,5 @@
 (in-package "MONOM")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;;----------------------------------------------------------------
Index: /trunk/src/order.lisp
===================================================================
--- /trunk/src/order.lisp	(revision 97)
+++ /trunk/src/order.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: order.lisp,v 1.4 2009/01/23 10:39:41 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -35,5 +35,5 @@
 (in-package "ORDER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;; pure lexicographic
Index: /trunk/src/parse.lisp
===================================================================
--- /trunk/src/parse.lisp	(revision 97)
+++ /trunk/src/parse.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: parse.lisp,v 1.11 2009/01/22 04:05:13 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -19,5 +18,5 @@
 (in-package "PARSE")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;; The function PARSE yields the representations as above.  The two functions
Index: /trunk/src/poly-gcd.lisp
===================================================================
--- /trunk/src/poly-gcd.lisp	(revision 97)
+++ /trunk/src/poly-gcd.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: poly-gcd.lisp,v 1.4 2009/01/22 04:05:32 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -16,5 +16,5 @@
 (in-package "POLY-GCD")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;; This package calculates GCD of polynomials over integers.
Index: /trunk/src/poly-with-sugar.lisp
===================================================================
--- /trunk/src/poly-with-sugar.lisp	(revision 97)
+++ /trunk/src/poly-with-sugar.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: poly-with-sugar.lisp,v 1.3 2009/01/22 04:06:12 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -33,5 +33,5 @@
 (in-package "POLY-WITH-SUGAR")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;;----------------------------------------------------------------
Index: /trunk/src/poly.lisp
===================================================================
--- /trunk/src/poly.lisp	(revision 97)
+++ /trunk/src/poly.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: poly.lisp,v 1.6 2009/01/22 04:05:52 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -18,5 +18,5 @@
 (in-package "POLY")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;;----------------------------------------------------------------
Index: /trunk/src/printer.lisp
===================================================================
--- /trunk/src/printer.lisp	(revision 97)
+++ /trunk/src/printer.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: printer.lisp,v 1.3 2009/01/22 04:06:32 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -15,5 +15,5 @@
 (in-package "PRINTER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun poly-print (plist vars &optional (stream t))
Index: /trunk/src/prover.lisp
===================================================================
--- /trunk/src/prover.lisp	(revision 97)
+++ /trunk/src/prover.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: prover.lisp,v 1.3 2009/01/22 04:06:51 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -19,5 +18,5 @@
 (in-package "PROVER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defvar *prover-order* #'grevlex>
Index: /trunk/src/rat.lisp
===================================================================
--- /trunk/src/rat.lisp	(revision 97)
+++ /trunk/src/rat.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: rat.lisp,v 1.4 2009/01/22 04:07:12 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -28,5 +28,5 @@
 (in-package "RAT")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun num (p) (car p))			;numerator
Index: /trunk/src/ratpoly.lisp
===================================================================
--- /trunk/src/ratpoly.lisp	(revision 97)
+++ /trunk/src/ratpoly.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: ratpoly.lisp,v 1.4 2009/01/22 04:07:33 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -34,5 +34,5 @@
 (in-package "RATPOLY")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;; Arithmetic on polynomials in one variable
Index: /trunk/src/string-grobner.lisp
===================================================================
--- /trunk/src/string-grobner.lisp	(revision 97)
+++ /trunk/src/string-grobner.lisp	(revision 98)
@@ -1,5 +1,4 @@
 ;;; -*- Mode: Common-Lisp; Package: String-Grobner; Base: 10 -*-
 #|
-	$Id: string-grobner.lisp,v 1.3 2009/01/22 04:07:58 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -30,5 +29,5 @@
 (in-package "STRING-GROBNER")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun string-normal-form (f fl vars
Index: /trunk/src/svpoly.lisp
===================================================================
--- /trunk/src/svpoly.lisp	(revision 97)
+++ /trunk/src/svpoly.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: svpoly.lisp,v 1.4 2009/01/23 10:37:28 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -14,5 +14,5 @@
 (in-package "SVPOLY")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defstruct (svpoly (:constructor make-svpoly-raw))
Index: /trunk/src/term.lisp
===================================================================
--- /trunk/src/term.lisp	(revision 97)
+++ /trunk/src/term.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: term.lisp,v 1.4 2009/01/22 04:08:39 marek Exp $	
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -16,5 +16,5 @@
 (in-package "TERM")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 ;;----------------------------------------------------------------
Index: /trunk/src/trivial.lisp
===================================================================
--- /trunk/src/trivial.lisp	(revision 97)
+++ /trunk/src/trivial.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: trivial.lisp,v 1.1 2009/01/19 08:51:43 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
Index: /trunk/src/xgcd.lisp
===================================================================
--- /trunk/src/xgcd.lisp	(revision 97)
+++ /trunk/src/xgcd.lisp	(revision 98)
@@ -1,4 +1,4 @@
+;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: Grobner; Base: 10 -*-
 #|
-	$Id: xgcd.lisp,v 1.4 2009/01/22 04:09:05 marek Exp $
   *--------------------------------------------------------------------------*
   |  Copyright (C) 1994, Marek Rychlik (e-mail: rychlik@math.arizona.edu)    |
@@ -15,5 +15,5 @@
 (in-package "XGCD")
 
-(proclaim '(optimize (speed 3) (space 0) (safety 0) (debug 3)))
+(proclaim '(optimize (speed 0) (space 0) (safety 3) (debug 3)))
 
 (defun xgcd (X Y)