Index: branches/f4grobner/5am-tests.lisp
===================================================================
--- branches/f4grobner/5am-tests.lisp	(revision 1612)
+++ branches/f4grobner/5am-tests.lisp	(revision 1665)
@@ -125,5 +125,5 @@
 	 (t2 (make-term m2 9))
 	 (t3 (make-term m3 (* 7 9))))
-    (is (equalp (term-mul *ring-of-integers* t1 t2) t3))))
+    (is (equalp (term-mul +ring-of-integers+ t1 t2) t3))))
 
 (test termlist
@@ -157,5 +157,5 @@
   "Conversion to infix form"
   (is (equal 
-       (coerce-to-infix :term (make-term-variable *ring-of-integers* 5 3) '(x y z w u v))
+       (coerce-to-infix :term (make-term-variable +ring-of-integers+ 5 3) '(x y z w u v))
        '(* 1 (EXPT X 0) (EXPT Y 0) (EXPT Z 0) (EXPT W 1) (EXPT U 0)))))
 
@@ -237,5 +237,5 @@
 	 (y-sq (string->poly "y^2" '(x y)))
 	 (fl (cdr (string->poly "[x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -248,5 +248,5 @@
 	 (g (string->poly "x+2*y" '(x y)))
 	 (h (string->poly "x-2*y" '(x y)))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order)))
@@ -257,5 +257,5 @@
   "Buchberger algorithm"
   (let* ((fl (cdr (string->poly "[x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -268,5 +268,5 @@
   "Gebauer-Moeller algorithm"
   (let* ((fl (cdr (string->poly "[x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -278,5 +278,5 @@
   "Reduction algorithm"
   (let* ((fl (cdr (string->poly "[x^2,x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -296,5 +296,5 @@
   (let* (($poly_grobner_algorithm :buchberger)
 	 (fl (cdr (string->poly "[x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -310,5 +310,5 @@
   (let* (($poly_grobner_algorithm :buchberger)
 	 (fl (cdr (string->poly "[x+y,x-2*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -322,5 +322,5 @@
 	 (I (cdr (string->poly "[x^2*y,x*y^2]" '(x y))))
 	 (J (cdr (string->poly "[x,y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -333,5 +333,5 @@
 	 (f (string->poly "x^2-y^2" '(x y)))
 	 (g (string->poly "(x+y)^2" '(x y)))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -344,5 +344,5 @@
 	 (f (string->poly "y" '(x y)))
 	 (fl (cdr (string->poly "[x-y,x+y,y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order)))
@@ -355,5 +355,5 @@
 	 (fl (cdr (string->poly "[x,x-y,y]" '(x y))))
 	 (gl (cdr (string->poly "[x-y,x+2*y,y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order)))
@@ -368,5 +368,5 @@
 	 (F (cdr (string->poly F-str '(x y))))
 	 (P (string->poly "x^2" '(x y)))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (F-sat (append (cdr (string->poly F-str '(u x y)))
 			(cdr (string->poly "[u*x^2-1]" '(u x y))))))
@@ -379,5 +379,5 @@
 	 (F (cdr (string->poly F-str '(x y))))
 	 (P (cdr (string->poly "[x^2,x*y]" '(x y))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (F-sat (append (cdr (string->poly F-str '(u1 u2 x y)))
 			(cdr (string->poly "[u1*(x^2) + u2*(x*y)-1]" '(u1 u2 x y))))))
@@ -390,5 +390,5 @@
 	 (F (cdr (string->poly "[x^3*(y+z^2),x^2*(y-z^2)]" '(x y z))))
 	 (p (string->poly "x" '(x y z)))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -402,5 +402,5 @@
 	 (F (cdr (string->poly "[x^3*z*y,x*z*y^2]" '(x y z))))
 	 (P (cdr (string->poly "[x,z]" '(x y z))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -414,5 +414,5 @@
 	 (F (cdr (string->poly "[x^3*(y+z^2),x^2*(y-z^2)]" '(x y z))))
 	 (P (cdr (string->poly "[x]" '(x y z))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))
@@ -427,5 +427,5 @@
 	 (P1 (cdr (string->poly "[x]" '(x y z))))
 	 (P2 (cdr (string->poly "[z]" '(x y z))))
-	 (ring *ring-of-integers*)
+	 (ring +ring-of-integers+)
 	 (order #'lex>)
 	 (ring-and-order (make-ring-and-order :ring ring :order order))